[#ftl]
[#import "master.ftl" as master /]

[#assign header]
  <!-- Bibliotheken -->

  <script type="text/javascript" src="js/brainstormingController.js"></script>
  <script type="text/javascript" src="js/cardController.js"></script>
[/#assign]

[@master.page header=header logout=true]
<div lang="en" ng-app="brainstorming" ng-controller="BrainstormingController" data-framework="angularjs">
  <div id="main" ng-show="session.topics.length">
    <div id="topics-list" ng-show="session.state === 'ACTIVE'">
      <div class="topic-panel clearfix" ng-repeat="topic in session.topics" ng-class="{ completed: topic.completed, editing: topic == editedTopic, opened: openedTopic == topic.id, closed: openedTopic != topic.id }">
        <div ng-click="toggleTopic(topic)" class="header clearfix">
          <div class="content">
            {{topic.title}}
          </div>
          <div class="status"></div>
        </div>
        <div class="body" ng-show="openedTopic == topic.id">
          <div class="prompt-list" ng-show="topic.acceptsCards">
            <div class="prompt-panel clearfix" ng-class="{ opened:showPrompts == true, closed:showPrompts != true }">
              <div class="header clearfix" ng-click="togglePrompt()">
                <div class="content">
                  PROMPTS({{topic.prompts.length}})
                </div>
                <div  class="status"></div>
              </div>
              <div class="body" ng-show="showPrompts==true">
                <ul>
                  <li ng-repeat="prompt in topic.prompts">
                    {{prompt.text}}
                  </li>
                </ul>
              </div>
            </div>
          </div>
          <div class="editor clearfix" ng-show="topic.acceptsCards">
				    <form name="form" ng-controller="CardController" ng-submit="createCard(topic)">
				      <fieldset>
				        <legend>Karte erstellen</legend>
				        
				        <div class="controls clearfix">
  				        <div class="input">
  				          <div class="block clearfix">
  				            <label>TEXT:</label>
  				            <input type="text" name="text" ng-model="card.cardText" required />
  				          </div>
  				          <div class="block clearfix">
  				            <label>TYPE:</label>
  				            <select ng-model="card.cardType">
  				              <option value="METABASICELEMENT" selected="selected">META_ELEMENT</option>
  				              <option value="ACTIVITY">ACTIVITY</option>
  				              <option value="ENTITY">ENTITY</option>
  				              <option value="ROLE">ROLE</option>
  				              <option value="BASICMODIFIER">BASICMODIFIER</option>
  				            </select>
  				          </div>
  				        </div>
  				        
  				        <div class="action">
  				          <div>
  				            <input type="submit" value="SEND" ng-disabled="form.$invalid" />
  				          </div>
  				        </div>
				        <div>
				      </fieldset>
				    </form>
				  </div>
				  <div ng-show="!topic.acceptsCards">
				    Topic is closed
				  </div>
				  
				  <div class="card-list" ng-show="$parent.data.cards[topic.id].length">
				    <div class="card-panel clearfix" ng-class="{ opened: editMode == true, closed: editMode != true }">
  				    <div ng-click="toggleCard()" class="header clearfix">
  				      <div  class="content">
                  HISTORY({{$parent.data.cards[topic.id].length}})
                </div>
                <div  class="status"></div>
              </div>
              <div class="body" ng-show="editMode == true">
                <ul>
                  <li ng-repeat="card in $parent.data.cards[topic.id]" on-click="toggleComment()" ng-class="{ completed: card.completed, editing: card == editedCard }">
                    <div class="view">
                      {{card.text}}
                    </div>
                    <a href="#" editable-textarea="card.comment" e-style="color: green" e-required e-placeholder="Enter comment" onaftersave="createComment(card)">
                      <pre>{{(card.comment || 'Not commented')}}</pre>
                    </a>
                  </li>
                </ul>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    
    <div class="review-panel clearfix" ng-show="session.state === 'REVIEW'">
      <div class="header">
        COMMENT REQUEST FOR CARD:
        {{reviewedCard.text}}
      </div>
      <div class="body">
        <form ng-submit="reviewComment(reviewedCard)" ng-show="reviewedCard != null && !processedReview">
          <input  id="comment-request" ng-model="reviewedCard.comment">
          <input type="submit" value="Submit Comment">
        </form>
        <div id="no-comment-requested" ng-show="reviewedCard == null">
          NO CARDS TO REVIEW
        </div>
      </div>
    </div>
  </div>
</div>
[/@master.page]