<#macro page css=[] js=[] bodyclass="" header="" logout=false>
<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>${bundle('name')}</title>

  <style type="text/css">
    @import "css/brainstorming.css";
    @import "css/brainstorming-blue.css";
    @import "js/angular-xeditable/xeditable.css";
      <#if css??>
        <#list css as style>
        @import "${style}";
        </#list>
      </#if>
  </style>

  <script type="text/javascript" src="js/lib/jquery/jquery.js"></script>
  <script type="text/javascript" src="js/lib/angular/angular.js"></script>
  <script type="text/javascript" src="js/lib/angular-xeditable/xeditable.js"></script>
  <script type="text/javascript" src="js/lib/angular-hash-key-copier/hash-key-copier.js"></script>
  <script type="text/javascript" src="js/app.js"></script>

  <#if js??>
    <#list js as script>
      <script type="text/javascript" src="${script}"></script>
    </#list>
  </#if>

${header}
</head>
<body class="${bodyclass}">
<div id="fadeout">
  <div id="header">
    <div>
      <#if logout>
        <input type="button" name="logout" onclick="logout()" value="Logout" id="logout" />
      </#if>
    ${bundle('name')}
    </div>
  </div>
</div>
<div id="content">
  <#nested />
</div>
</body>
</html>
</#macro>
