'use strict';

brainstorming.controller('BrainstormingController', function BrainstormingController($scope, $http, $timeout, HashKeyCopier) {
	$scope.reviewedCard = null;
	$scope.reviewId = 0;
	$scope.processedReview = false;

	(function update() {
		$http.get('service?action=sessionInfo').success(function(data) {
			$scope.session = HashKeyCopier.copyHashKeys($scope.session, data);

			if (data.reviewedCardId) {
				if ($scope.reviewedCard == null || data.reviewedCardId !== $scope.reviewedCard.id) {

					$scope.processedReview = false;
					$http.get('service?action=cardInfo&cardId=' + data.reviewedCardId).success(function(card) {
						$scope.reviewedCard = card;
					});
				}
			} else {
				$scope.reviewedCard = null;
			}
			$timeout(update, 3000);
		});
	})();
	
	$scope.card = {
		cardText : "",
		cardType : "METABASICELEMENT"
	};

	$scope.prompts = null;
	$scope.openedTopic = null;
	$scope.openedCard = null;
	$scope.editedCard = null;
	$scope.editMode = false;
	$scope.showPrompts = false;
	$scope.showComment = false;

	$scope.data = {
		cards : {}
	};

	$scope.addCard = function(card, topic) {
		if (this.data.cards[topic.id] === undefined) {
			this.data.cards[topic.id] = [];
		}
		this.data.cards[topic.id].push(card);
	};

	$scope.createComment = function(card) {
		var comment = {
			'commentText' : card.comment,
			'id' : card.id
		};

		var json = JSON.stringify(comment);

		$http.put('service?action=updateCard', json);
	};

	$scope.reviewComment = function(card) {
		var comment = {
			'commentText' : card.comment,
			'id' : card.id
		};

		var json = JSON.stringify(comment);

		$http.put('service?action=updateCard', json).sucess;
		$scope.processedReview = true;
	};

	$scope.toggleTopic = function(topic) {
		$scope.openedTopic = $scope.openedTopic == topic.id ? null : topic.id;
	};

	$scope.toggleCard = function(card) {
		$scope.editMode = !$scope.editMode;
	};

	$scope.togglePrompt = function() {
		$scope.showPrompts = !$scope.showPrompts;
	};

	$scope.toggleComment = function() {
		$scope.showComment = !$scope.showComment;
	};

	$scope.editCard = function(card) {
		$scope.editedCard = card;
	};
	
	$scope.getKeyParameter = function() {		
		$scrope.key = $location.search('key');
	};
	
	
	
});