var TOPICNODE_TEMPLATE =
    "<div id=\'topic-{{ID}}\' class=\'topic-entry\'>\n" +
        "	<div id=\'prompts-{{ID}}\' class=\'prompts-wrapper prompts-closed\'>\n" +
        "		<div id=\'prompts-head-{{ID}}\' class=\'content-legend prompts-head\'>{{PROMPT}}\n" +
        "			<a href=\'#\' class=\'prompts-icon\'></a>\n" +
        "			<div style=\'clear: both;\'></div>\n" +
        "		</div>\n" +
        "		<div class=\'content-body \' id=\'prompt-div-{{ID}}\'>\n" +
        "			<div id=\'active-prompt-{{ID}}\'>No prompt available</div>\n" +
        "		</div>\n" +
        "		<div class=\'content-body all-prompts-body\' id=\'all-prompts-{{ID}}\'>{{PROMPTS}}</div>\n" +
        "	</div>\n" +
        "	\n" +
        "	<div class=\'content-legend\' id=\'legend-{{ID}}\'>{{CREATE_CARD}}</div>\n" +
        "	<div class=\'content-body topic-editor\' id=\'editor-{{ID}}\'>\n" +
        "		<div id=\'editor-body-{{ID}}\' style=\'width: 100%\'>" +
        "			<div style=\'width: 70%; float: left;\'>\n" +
        "				<div style=\'padding-bottom: 5px;\'>\n" +
        "					<label style=\'float: left; width: 15%;\' for=\'text-{{ID}}\'>{{TEXT}}:</label>\n" +
        "					<input type=\'text\' id=\'text-{{ID}}\'/>\n" +
        "				</div>\n" +
        "				<div style=\'clear: both;\'>\n" +
        "					<label style=\'float: left; width: 15%;\' for=\'type-{{ID}}\'>{{CARD_TYPE}}:</label>\n" +
        "					<select id=\'type-{{ID}}\' style=\'\'>\n" +
        "						<option value=\'METABASICELEMENT\' selected=\'selected\'>{{META_ELEMENT}}</option>\n" +
        "						<option value=\'ACTIVITY\'>{{ACTIVITY}}</option>\n" +
        "						<option value=\'ENTITY\'>{{ENTITY}}</option>\n" +
        "						<option value=\'ROLE\'>{{ROLE}}</option>\n" +
        "						<option value=\'BASICMODIFIER\'>{{BASICMODIFIER}}</option>\n" +
        "					</select>\n" +
        "				</div>\n" +
        "			</div>\n" +
        "			<div style=\'width: 30%; float: right;\' >\n" +
        "				<input type=\'button\' style=\'width: 100%; height: 100%; font-size: 40px;\' value=\'{{SEND}}\' id=\'send-{{ID}}\'/>\n" +
        "			</div>\n" +
        "			<div style=\'clear: both;\'></div>\n" +
        "		</div>\n" +
        "		<div id=\'closed-info-{{ID}}\' style=\'display: none;\'>{{CLOSED_INFO}}</div>\n" +
        "	</div>\n" +
        "	\n" +
        "	<div id=\'history-{{ID}}\' class=\'history-wrapper history-closed\'>\n" +
        "		<div class=\'content-legend history-head\' id=\'history-head-{{ID}}\'>\n" +
        "			{{HISTORY}}\n" +
        "			<a href=\'#\' class=\'history-icon\'></a>\n" +
        "			<div style=\'clear: both;\'></div>\n" +
        "		</div>\n" +
        "		<div class=\'content-body history-body\' id=\'history-body-{{ID}}\'></div>\n" +
        "	</div>\n" +
        "</div>";

SeeMeYUI.use("gallery-accordion", "console", "node", "io-queue", "json-parse", "json-stringify", function (Y) {

    createPromptsMarkup = function (current, prompts) {
        if (!prompts) {
            return "";
        }
        var markup = "";
        for (var i = 0; i < prompts.length; i++) {
            if (current == prompts[i]) {
                continue;
            }
            markup += "<div class='prompt-entry' id='prompt-" + prompts[i] + "'";
            markup += ">" + prompts[i].text + "</div>";
        }
        return markup;
    };

    /**
     * Topic Klasse
     */
    Topic = function (data, topicController) {
        this.topicController = topicController;

        this.ICON_NODE = Y.Node.create("<span class='state-icon'></span>");
        console.debug("Data: "+ data);
        var item = new Y.AccordionItem({
            label: data,
            expanded: false,
            iconAlwaysVisible: Y.Node.create("<span></span>"),
            icon: this.ICON_NODE,
            id: "topic-item-" + data,
            contentHeight: {
                method: "auto"
            }
        });

        var markup = TOPICNODE_TEMPLATE.replace(/{{ID}}/g, data).replace(/{{PROMPTS}}/g, createPromptsMarkup(this, []));
        markup = localizeTemplate(markup);
        var body = Y.Node.create(markup);
        item.set("bodyContent", body);

        this.data = data;
        this.accordionItem = item;
        this.node = body;

        this.cards = [];

        this.proposed = false;

        this.updatePrompts();
        this.updateStateIcon();
        this.initListeners();
    };

    Topic.prototype = {

        getTopicController: function () {
            return this.topicController;
        },
        getData: function () {
            return this.data;
        },
        getAccordionItem: function () {
            return this.accordionItem;
        },
        getText: function () {
            return this.getData().name;
        },
        getId: function () {
            return this.getData();
        },

        update: function (data) {
            this.data = data;

            this.getAccordionItem().set("label", data.name);

            this.updatePrompts();
            this.updateStateIcon();
            this.updateEditorState();

            this.getAccordionItem().resize();
        },

        updatePrompts: function () {
            var data = this.getData(),
                currentPrompt = this.getCurrentPrompt(),
                prompts = data.prompts,
                seenPrompts = data.seenPrompts,
                promptsNode = this.node.one("#prompts-" + data),
                facilitated = false,//this.getTopicController().getSession().facilitated,
                renderedPrompts = facilitated ? seenPrompts : prompts;
                return;
            if ((!renderedPrompts || renderedPrompts.length == 0) && !currentPrompt) {
              
            	promptsNode.hide();
                return;
            } else {
                promptsNode.show();
            }

            this.renderCurrentPrompt();
            this.renderPrompts(renderedPrompts);
        },

        renderCurrentPrompt: function () {
            var prompt = this.getCurrentPrompt(),
                id = this.getId(),
                promptNode = this.node.one("#prompt-div-" + id),
                node = this.node.one("#active-prompt-" + id);

            if (!node) {
                return;
            }

            if (!prompt) {
                promptNode.hide();
                return;
            }

            node.set("innerHTML", prompt.text);
            promptNode.show();
        },

        renderPrompts: function (prompts) {
            this.node.one("#all-prompts-" + this.data).set("innerHTML", createPromptsMarkup(this, prompts));
            this.getAccordionItem().resize();
        },

        updateEditorState: function () {
            var ci = this.node.one("#closed-info-" + this.data);
            var ed = this.node.one("#editor-body-" + this.data);
            if (this.data.state == 'CLOSED' && ed != null && ci != null) {
                ed.hide();
                ci.show();
            } else {
            	if(ed != null && ci != null) {
                ed.show();
                ci.hide();
            	}
            }
        },

        updateStateIcon: function () {
            var sc = null;
            if (this.proposed) {
                sc = 'state-PROPOSED';
            }
            if (this.data.state == 'CLOSED') {
                sc = 'state-CLOSED';
            }

            if (this.stateClass != null) {
                this.ICON_NODE.removeClass(this.stateClass);
            }
            if (sc != null) {
                this.ICON_NODE.addClass(sc);
            }
            this.stateClass = sc;
        },

        addCard: function (card) {
            this.cards[this.cards.length] = card;

            var e = card.getHistoryHtmlElement();
            Y.one("#history-body-" + this.data).insert(e, 0);
            card.init(this.accordionItem);
            this.accordionItem.resize();
        },

        sendAction: function (e) {
            var id = this.data;
            var session = this.getTopicController().getSession();
            var sendBtn = Y.one("#send-" + id).set("disabled", true);
            var textInput = Y.one("#text-" + id).set("disabled", true);

            var text = textInput.get("value");
            var type = Y.one("#type-" + id).get("value");

            if (text.replace(/\s/g, "") == "") {
                alert(getLocalizedString("EMPTY_TEXT_ERROR"));
            } else {
                var card = new Card(type, text, this);
                var json = Y.JSON.stringify({
                    'text': text,
                    'cardType': type,
                    'topic': id
                });
                var cfg = {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json'
                    },
                    data: json,
                    on: {
                        success: this.handleSuccess,
                        failure: this.handleFailure
                    },
                    arguments: card,
                    context: this
                };

                this.addCard(card);
                Y.io.queue.stop();
                Y.io.queue("service?action=createCard", cfg);
                Y.io.queue.start();
            }

            textInput.set("value", "");
            sendBtn.set("disabled", false);
            textInput.set("disabled", false);
            textInput.focus();
        },

        handleFailure: function (ioId, o, card) {
            card.setState('failure');
        },

        handleSuccess: function (ioId, o, card) {
            var result = Y.JSON.parse(o.responseText);
            card.setState(result.state);
            if (result.id) {
                card.setId(result.id);
            }
        },

        toggleHistory: function (e) {
            var h = Y.one("#history-" + this.data);
            h.toggleClass("history-closed");
            h.toggleClass("history-opened");
            this.getAccordionItem().resize();
            this.focus();
        },

        togglePrompts: function (e) {
            var h = Y.one("#prompts-" + this.data);
            h.toggleClass("prompts-closed");
            h.toggleClass("prompts-opened");
            this.getAccordionItem().resize();
            this.focus();
        },

        focus: function () {
            this.node.one("#text-" + this.data).focus();
            this.updateEditorState();

            var topicController = this.getTopicController(),
                participantId = topicController.getSessionController().getParticipantId(),
                session = topicController.getSession(),
                facilitated = false;//session.facilitated;

            if (facilitated) {
                Y.io("/facilitator/api?action=topic-selected&topic=" + this.data + "&client=" + participantId + "&session="
                    + session.id);
            }
        },

        lostFocus: function () {
            var topicController = this.getTopicController(), participantId = topicController.getSessionController()
                .getParticipantId(), session = topicController.getSession(), facilitated = session.facilitated;

            if (facilitated) {
                Y.io("/facilitator/api?action=topic-closed&topic=" + this.data + "&client=" + participantId + "&session="
                    + session.id);
            }
        },

        checkSendAfterEnter: function (e) {
            if (e.keyCode == 13) {
                this.sendAction(e);
            }
        },

        initListeners: function () {
            var node = this.node;
            node.one("#send-" + this.data).on('click', this.sendAction, this);
            node.one("#text-" + this.data).on('keypress', this.checkSendAfterEnter, this);
            node.one("#history-head-" + this.data).on('click', this.toggleHistory, this);
            node.one("#prompts-head-" + this.data).on('click', this.togglePrompts, this);
        },

        getPromptById: function (pid) {
            for (var i = 0; i < this.data.prompts.length; i++) {
                var prompt = this.data.prompts[i];
                if (prompt.id == pid) {
                    return prompt;
                }
            }
        },

        setCurrentPrompt: function (prompt) {

            if (this.currentPrompt != prompt) {
                var session = this.getTopicController().getSession(), sessionController = this.getTopicController()
                    .getSessionController(), participantId = sessionController.getParticipantId(), json = Y.JSON.stringify({
                    'state': 'seen'
                }), cfg = {
                    method: 'PUT',
                    headers: {
                        'Content-Type': 'application/json'
                    },
                    data: json
                };

                if (!this.hasSeenPrompt(prompt)) {
                    sessionController.showNewPromptAlert();
                }

                Y.io.queue.stop();
                Y.io.queue("rest/sessions/" + session.id + "/clients/" + participantId + "/prompts/" + prompt.id, cfg);
                Y.io.queue.start();
            }

            this.currentPrompt = prompt;
            this.updatePrompts();
        },

        setProposed: function (p) {
            this.proposed = p;
            this.updateStateIcon();
        },

        isProposed: function () {
            return this.proposed;
        },

        hasPrompts: function () {
            return (this.data.prompts && (this.data.prompts.length > 0));
        },

        showPrompt: function (prompt) {
            if (typeof prompt == "string") {
                prompt = this.getPromptById(prompt);
            }
            this.setCurrentPrompt(prompt);
        },

        getCurrentPrompt: function () {
            return this.currentPrompt;
        },

        hasSeenPrompt: function (prompt) {
            var seenPrompts = this.data.seenPrompts;
            if (!seenPrompts) {
                return false;
            }

            for (var i = 0; i < seenPrompts.length; i++) {
                if (seenPrompts[i] = prompt.id) {
                    return true;
                }
            }
            return false;
        }
    };
});
